/**
 * Created by sinfeh on 6/23/2015.
 */
sap.ui.define(['jquery.sap.global', 'sas/hc/m/SelectListRenderer', 'sap/ui/core/Renderer', 'sas/hc/m/fontChooser/CustomStyleItem'],
    function(jQuery, sasSelectListRenderer, Renderer, CustomStyleItem) {

        //Retained most of the code as per existing strategy of manipulating dom obtained from
        //SASSelectListRenderer, but have cleaned up some ugly part
        //Which was nothing but copied code from SAP's SelectListRenderer.

        //I feel the SelectList itself has a basic flaw of not delegating item rendering to the Items themselves.

        var CustomSelectListRenderer = Renderer.extend(sasSelectListRenderer);

        /**
         * hiding the SAS's SelectListRenderer to achieve a manipulated DOM to be flushed.
         *
         * @public
         */
        CustomSelectListRenderer.render = function(oRm, oControl) {
            var $customSelectListHeaderDiv = this._getHTMLDom(oRm, oControl),
                $myMITHDiv = $customSelectListHeaderDiv.find('#' + oControl.getId());
            this._manipulatingMITHTabs(oRm, oControl, $myMITHDiv);
            oRm.write($customSelectListHeaderDiv.html());
        };

        CustomSelectListRenderer._manipulatingMITHTabs = function(oRm, oControl, $myMITHDiv) {
            var aItems = oControl.getItems();

            jQuery.each(aItems, function(iIndex, oItem) {
                if (oItem instanceof CustomStyleItem) {
                    var $itemDiv = $myMITHDiv.find('#' + oItem.getId());
                    $itemDiv.addClass("sasFCFontFace");
                    var sStyle = oItem.getStyle() + ":" + oItem.getKey() + " !important";
                    $itemDiv.attr("style", sStyle);
                }
            });
        };

        //Retaining this function as per old code.
        CustomSelectListRenderer.writeAccessibilityState = function(oRm, oList) {
            oRm.writeAccessibilityState({
                role: "listbox"
            });
        };


        CustomSelectListRenderer._getHTMLDom = function(oRm, oControl) {
            var myRendererRef = CustomSelectListRenderer.render;
            CustomSelectListRenderer.render = sasSelectListRenderer.render;
            var html = oRm.getHTML(oControl);
            CustomSelectListRenderer.render = myRendererRef;

            return $('<div></div>', {
                html: html
            });
        };

        return CustomSelectListRenderer;
    }, true);