jQuery.sap.declare("sas.hc.ui.commons.banner.Banner");

jQuery.sap.require("sap.m.library"); // DataTypes:[OverflowToolbarPriority]

jQuery.sap.require("sas.hc.ui.services.search.CincoSearchField");
jQuery.sap.require("sas.hc.m.BannerHeading");
jQuery.sap.require("sas.hc.m.Button");
jQuery.sap.require("sas.hc.m.Dialog");
jQuery.sap.require("sas.hc.m.Image");
jQuery.sap.require("sas.hc.m.Menu");
jQuery.sap.require("sas.hc.m.MenuButton");
jQuery.sap.require("sas.hc.m.MenuItem");
jQuery.sap.require("sas.hc.m.OverflowToolbarLayoutData");
jQuery.sap.require("sas.hc.m.ResponsiveToolbar");
jQuery.sap.require("sas.hc.m.ToolbarSpacer");
jQuery.sap.require("sas.hc.ui.commons.notifications.NotificationsBadge");
jQuery.sap.require("sas.hc.ui.commons.banner.help.HelpAboutController");
jQuery.sap.require("sas.hc.ui.commons.banner.help.DefaultHelpPage");
jQuery.sap.require("sas.hc.ui.commons.recent.RecentDialog");
jQuery.sap.require("sas.hc.ui.core.util.UserInfo");
jQuery.sap.require("sas.hc.ui.core.util");
jQuery.sap.require("sas.hc.ui.core.util.ServicesUtil");
jQuery.sap.require("sas.hc.ui.core.util.SignoutService");
jQuery.sap.require("sas.hc.ui.core.library"); // DataTypes:[SETTINGS_CHANGE, SETTINGS_CHANNEL]
jQuery.sap.require("sas.hc.ui.commons.AppSwitcherMenu");

jQuery.sap.require("sap.ui.core.Control");
jQuery.sap.require("sap.ui.core.Core");
jQuery.sap.require("sas.hc.ui.core.Core");
jQuery.sap.require("sas.hc.ui.core.GlobalSettings");
jQuery.sap.require("sas.hc.ui.core.theme.ApplicationTheme");
jQuery.sap.require("sap.m.OverflowToolbarLayoutData");

(function(){


    var sapMLib = sap.m,
        sasCoreLib = sas.hc.ui.core;
    function setupAppSwitcherMenu() {
        // If app switcher is disabled then sas.applicationSwitcher will not exist
        if(sas.applicationSwitcher && this._appswitchMenu === undefined) {
            var currentId = this.getId();

            this._appswitchMenu = new sas.hc.ui.commons.AppSwitcherMenu(currentId+"_asm");
            this.setAggregation("appswitcherMenu", this._appswitchMenu);
            this._appswitchMenu.populate();
            var that=this;
            // listen for app data updated event and react to it by updating push menu.
            sas.applicationSwitcher.subscribe(sas.applicationSwitcher.APP_INFO_CHANGED_MESSAGETYPE, function(type,data){
                // update push menu
                that._appswitchMenu.populate();
            });

            this._appswitchMenu.attachItemSelected(function(e) {
                that._appswitchMenu.collapse(true);
                var item = e.getParameter("item");
                sas.applicationSwitcher.gotoApp(item.appId, item.url, item.appSwitcherCompliance, {}, false, e.getParameter("ctrlKey"));
            });

            var closePushMenu=function(e) {
                if(e.type==="keyup" && e.keyCode!==27) return;
                if(e.type!=="keyup" &&
                    (document.getElementById(that._appswitchMenu.getId()).contains(e.target) ||
                     document.getElementById(that.pushMenuButton.getId()).contains(e.target)))
                    return;
                that._appswitchMenu.collapse();
            };
            this._appswitchMenu.attachStartExpand(function(e) {
                var parentContainerEl = that.getParent().$();
                parentContainerEl.on('click.contentArea', closePushMenu);
                $(document).keyup(closePushMenu);
            });

            this._appswitchMenu.attachEndCollapse(function(e) {
                var parentContainerEl = that.getParent().$();
                parentContainerEl.off('click.contentArea');
                $(document).unbind("keyup", closePushMenu);
            });
        }
    };

    /**
     * @class
     * @extends sap.ui.core.Control
     *
     * @constructor
     * @public
     * @name sas.hc.ui.commons.banner.Banner
     */
    sap.ui.core.Control.extend("sas.hc.ui.commons.banner.Banner", {
        metadata:
        {
            library: "sas.hc.ui.commons",
            publicMethods:
            [
                "setPushMenuModel"
            ],
            properties:
            {
                "text": {type: "string", group: "Appearance", defaultValue: ""},

                // This is optional heading text to the right of the "task".  Task must exist or this is ignored.
                "subText": {type: "string", group: "Appearance", defaultValue: ""},

                // This is an optional string displayed to the right of the app name.  This is known externally
                // as the "verb".
                "task": {type: "string", group: "Appearance", defaultValue: ""},

                /* This should rarely be used.  Only for non WIP enabled apps */
                "userName": {type: "string", group: "Appearance", defaultValue: ""},

                /* Optional customer logo image */
                "logoSource": {type: "string", group: "Misc", defaultValue: sas.icons.HC.SASLOGOWHITE},

                /* This should rarely be used.  Only for non WIP enabled apps */
                "signoutUrl": {type: "string", group: "Appearance", defaultValue: undefined},

                "avatar": {type: "sap.ui.core.URI", group: "Appearance", defaultValue: sas.icons.HC.BANNERSETTINGS},
                "defaultAvatar": {type: "boolean", group: "Appearance", defaultValue: true},

                /* This should rarely be used.  Only for non WIP enabled apps */
                "helpUrl": {type: "string", group: "Appearance", defaultValue: ""},
                "showSearch": {type: "boolean", group: "Appearance", defaultValue: true},
                "showLogo": {type: "boolean", group: "Appearance", defaultValue: false},
                "showThemeDesigner": {type: "boolean", group: "Appearance", defaultValue: true},
                "showNotifications": {type: "boolean", group: "Appearance", defaultValue: true},
                "showPushMenu": {type: "boolean", group: "Appearance", defaultValue: false},
                "showRecents": {type: "boolean", group: "Appearance", defaultValue: true},
                "showOptionsMenu": {type: "boolean", group: "Appearance", defaultValue: true},
                "alwaysShowHelp": {type: "boolean", group: "Appearance", defaultValue: false},
                "showSettings": {type: "boolean", group: "Appearance", defaultValue: true}

            },
            aggregations:
            {
                /* hidden aggregations. */
                "appswitcherMenu": {type: "sas.hc.ui.commons.AppSwitcherMenu", multiple: false, visibility: "hidden"},
                /* These actually disappear when they are added to the Toolbar since they can't be in two aggregations.  */
                // TODO remove them
                "recentsButton": {type: "sas.hc.m.Button", multiple: false, visibility: "hidden"},
                "pushMenuButton": {type: "sas.hc.m.Button", multiple: false, visibility: "hidden"},
                "appTextControl": {type: "sas.hc.m.BannerHeading", multiple: false, visibility: "hidden"},
                "search": {type: "sas.hc.ui.services.search.CincoSearchField", multiple: false, visibility: "hidden"},
                "notifications": {type: "sas.hc.ui.commons.notifications.NotificationsBadge", multiple: false, visibility: "hidden"},
                "helpButton": {type: "sas.hc.m.MenuButton", multiple: false, visibility: "hidden"},
                "optionsButton": {type: "sas.hc.m.MenuButton", multiple: false, visibility: "hidden"},
                "toolbar": {type: "sas.hc.m.ResponsiveToolbar", multiple: false, visibility: "visible"},
                "toolbarSpacer": {type: "sas.hc.m.ToolbarSpacer", multiple: false, visibility: "visible"},
                "logo": {type: "sas.hc.m.Image", multiple: false, visibility: "hidden"}
            },
            events:{
                beforeTogglePushMenu:{
                     //Preventable
                    allowPreventDefault: true,
                    parameters:{
                        // to determine state
                        collapsed: {type: "boolean"}
                    }
                },
                beforeShowSettings: {
                    //Preventable
                    allowPreventDefault: true
                }
            }
        },

        /* resource bundle for banner */
        rb : sap.ui.getCore().getLibraryResourceBundle("sas.hc.ui.commons"),


        logger: sas.log.getLogger("sas.hc.ui.commons.banner.Banner", sas.log.Level.ERROR),

        // This is used to determine if init has been called. When the consumer calls one of the "show" method,
        // this allows us determine if we need to recreate the control or simple re-add it to the ResponsiveToolbar
        // content.
        _bInitialized: false,

        // Internal use only.
        _dummy: 0,

        responsiveMetadata: {
            invalidateAfterResponsiveChange: true
        }
    });

    /**
     *  This happens when the optionsButton overflows.  It's the last thing to overflow, so at this point, reduce the
     *  Heading to just the task part, if there is one.
     *
     * @param oEvent
     * @private
     */
    sas.hc.ui.commons.banner.Banner.prototype._handleOverflow = function(oEvent) {

        // If the options button is overflowing, we are down to just the apptext.  If it has a task part,
        // hide the app text to get a little more room.
        if (this.getShowOptionsMenu() && oEvent.mParameters.getId() === this.optionsButton.getId()) {
            if (this.bannerText.getTask() && this.bannerText.getTask().length > 0)  {
                this.bannerText.setShowText(false);
            }
        }

    };

    /**
     *  This happens when the optionsButton is restored.  It's the last thing to overflow and is first restored, so at this point, restore the
     *  Heading to the appname and task, if there is one.
     *
     * @param oEvent
     * @private
     */
    sas.hc.ui.commons.banner.Banner.prototype._handleRestore = function(oEvent) {

        // If the options button is restored, restore the apptext.
        if (this.getShowOptionsMenu() && oEvent.mParameters.getId() === this.optionsButton.getId()) {
            if (this.bannerText.getTask())  {
                this.bannerText.setShowText(true);
            }
        }

    };


    /**
     * If the toolbar/banner increases in width, see if we can dynamically restore the searchfield or the options button.
     * This is also called if the Heading changes (e.g. task name changes or the app text is hidden)
     *
     * @param oEvent
     * @private
     */
    sas.hc.ui.commons.banner.Banner.prototype._handleAdditionalSpace = function(oEvent) {

        // If we're showing the search button or options w/o text see if the additional space could accommodate restoring
        // either one or both.
        var tb = this.getAggregation("toolbar");

        // Get local copies of values, since they will change if we change the TB contents.
        var iPreviousToolbarWidth = tb._iPreviousToolbarWidth ? tb._iPreviousToolbarWidth :  tb.$().outerWidth(true);
        var iContentSize = tb._iContentSize;

        // If the  options button is icon only, check if there's now room to restore the text.
        // Restore options first, since it's smaller.
        if (this.optionsButton) {
            if (this.optionsButton.getText().length === 0 && this.optionsButton._iOptimalWidthOriginal){

                // Find how much we need.
                var diff1 = this.optionsButton._iOptimalWidthOriginal - this.optionsButton._iOptimalWidth;
                // For options, find a way to keep track of the original size.   Probably in the method right above.
                if (iPreviousToolbarWidth - iContentSize > diff1) {

                    // If either the avatar doesn't exist or it has not been customized we display the user's name and
                    // we do not display the avatar.
                    if (this.getDefaultAvatar()) {
                        this.optionsButton.setText(this.getUserName());
                        this.optionsButton.setIcon(null);

                        // Reset avatar tooltip
                        var toolTip = this.rb.getText("banner.optionsMenu.tip");
                        this.optionsButton.setTooltip(toolTip);
                    }

                    iContentSize += diff1;
                }
            }
        }

        // Do search.
        if (this.searchField && this.searchButton) {
            var diff2 = (this.searchField._iOptimalWidth ? this.searchField._iOptimalWidth : 224) - (this.searchButton._iOptimalWidth ? this.searchButton._iOptimalWidth : 36);
            if (tb.indexOfContent(this.searchButton) !== -1 && iPreviousToolbarWidth - iContentSize > diff2) {
                // we can restore the searchfield.
                var index = this.getAggregation("toolbar").indexOfContent(this.searchButton);
                this.getAggregation("toolbar").removeContent(this.searchButton);
                this.getAggregation("toolbar").insertContent(this.searchField, index);
            }
        }


    };

    /**
     * If the toolbar is smaller, dynamically make a couple of changes to create more room: first change the search field to
     * a search button, second change the options button to icon-only.
     *
     * @param oEvent
     * @private
     */
    sas.hc.ui.commons.banner.Banner.prototype._handleLessSpace = function(oEvent) {

        // If we're showing the search button or options w/o text see if the additional space could accommodate restoring
        // either one or both.
        var tb = this.getAggregation("toolbar");

        // Get local copies of values, since they will change if we change the TB contents.
        var iPreviousToolbarWidth = tb._iPreviousToolbarWidth ? tb._iPreviousToolbarWidth :  tb.$().outerWidth(true);
        var iContentSize = tb._iContentSize;

        // Do search.  TODO: something about the hardcoded button width.
        if (this.searchField && this.searchButton) {

            // there's a case where the search field is added when there's no room or not enough room and the field is not rendered and instead
            // the search button is rendered.   When it's not rendered, it has no _iOptimateWidth.  So hardcode something in this probably
            // rare situation (actually just the banner HC sample).
            var diff2 = (this.searchField._iOptimalWidth ? this.searchField._iOptimalWidth : 224) - (this.searchButton._iOptimalWidth ? this.searchButton._iOptimalWidth : 36);
            if (iContentSize > iPreviousToolbarWidth && tb.indexOfContent(this.searchField) !== -1) {
                // we swap out the searchfield.
                var index = this.getAggregation("toolbar").indexOfContent(this.searchField);
                this.getAggregation("toolbar").removeContent(this.searchField);
                this.getAggregation("toolbar").insertContent(this.searchButton, index);

                // Decrease the total by how much we saved.
                iContentSize -= diff2;
            }
        }

        // If the content doesn't fit and the optionsButton has text, then reset the text to make it smaller.
        if (this.optionsButton) {
            if (iContentSize > iPreviousToolbarWidth && this.optionsButton.getText().length !== 0){

                if (!this.optionsButton._iOptimalWidthOriginal) {
                    // Before we make it icon only, save the original size.
                    this.optionsButton._iOptimalWidthOriginal =  this.optionsButton._iOptimalWidth;
                }

                // Remove the user name and show the avatar regardless of whether the user has customized one.
                this.optionsButton.setText("");
                this.optionsButton.setIcon( this.getAvatar() );

                // Change the tooltip so that it includes more info.
                var toolTip = this.rb.getText("banner.avatar.fmt", [this.rb.getText("banner.userName.txt"),this.getUserName()]);
                this.optionsButton.setTooltip(toolTip);
                this.optionsButton.setShowDownArrowIconOnly(true);
            }
        }
    };



    /**
     * Initialize the SAS Banner control
     *
     * @method
     */
    sas.hc.ui.commons.banner.Banner.prototype.init = function(){
        this.addStyleClass("sasDark");

        var oToolbar = new sas.hc.m.ResponsiveToolbar({
            id: this.getId() + "-toolbar",
            width: "100%"
        });
        this.setAggregation("toolbar", oToolbar);

        oToolbar.attachEvent("additionalSpaceAvailable", $.proxy(this._handleAdditionalSpace, this));
        oToolbar.attachEvent("lessSpaceAvailable", $.proxy(this._handleLessSpace, this));
        oToolbar.attachEvent("beforeOverflow", $.proxy(this._handleOverflow, this));
        oToolbar.attachEvent("beforeRestoreToToolbar", $.proxy(this._handleRestore, this));

        // Listen for browser resize.
        $(window).on('resize', jQuery.proxy(this._onBrowserResize, this));

        var oOverflowButton = this.getAggregation("toolbar")._getOverflowButton();
        oOverflowButton.setDesign(sas.hc.m.MenuButton.Design.LightweightPrimary);

        var overflowButtonTooltip = this.rb.getText("banner.overflowButton.fmt", [this.rb.getText("banner.userName.txt"),this.getUserName()]);
        oOverflowButton.setTooltip(overflowButtonTooltip);

        // Find out if settings is available for this user.
        this._isSettingsAvailable();



        // Subscribe to a change to the avatar.
        sas.eventBus.subscribe(sasCoreLib.SETTINGS_CHANNEL,
            sasCoreLib.SETTINGS_CHANGE,
            this._handleSettingsChange, this);

        this._createHelpControl();

        this._showTextControl(true);

        // S1345373: Remove Recents from WIP
        if (sas && sas.registry && sas.registry.wip) {
            this.setShowRecents(false);
        } else {
            this.setShowRecents(this.getShowRecents());
        }

        if (this.getShowNotifications() === true) {
            this._createNotificationsControl();
        }

        if (this.getShowSearch()) {
            this._createSearchControl();
        }

        this._setupThemeDesigner();
        this._createHelpController();

        this.setShowPushMenu(sas.applicationSwitcher && sas.applicationSwitcher.availableApplications.length>0);


        if (this.getAggregation("pushMenuButton") && this.getShowPushMenu()) {
            oToolbar.addContent(this.getAggregation("pushMenuButton"));
        }

        if (this.getAggregation("appTextControl")) {
            oToolbar.addContent(this.getAggregation("appTextControl"));
        }

        this.toolbarSpacer = new sas.hc.m.ToolbarSpacer();
        this.setAggregation("toolbarSpacer", this.toolbarSpacer);

        oToolbar.addContent(this.toolbarSpacer);

        if (this.getAggregation("search") && this.getShowSearch()) {
            oToolbar.addContent(this.getAggregation("search"));
        }

        if (this.getAggregation("recentsButton") && this.getShowRecents()) {
            oToolbar.addContent(this.getAggregation("recentsButton"));
        }

        if (this.getAggregation("notifications") && this.getShowNotifications()) {
            oToolbar.addContent(this.getAggregation("notifications"));
        }

        if (this.getAggregation("helpButton")) {
            oToolbar.addContent(this.getAggregation("helpButton"));
        }

        this.setShowOptionsMenu(this.getShowOptionsMenu());

        // Get the avatar.  Do this after the option button is created.
        if (this.getShowOptionsMenu()) {
            this._getAvatar();
        }

        // Subscribe to the themeChanged event with a handler that sets the banner logo if the new theme contains one
        sas.eventBus.subscribe("Themes", "applicationThemeChanged", this._handleBannerImage, this);

        // Call the handler initally to set the banner logo if specified
        this._handleBannerImage("Themes", "applicationThemeChanged", {themeId: sap.ui.getCore().getConfiguration().getTheme()});

        this._bInitialized = true;

    };

    /**
     * Event handler. Called when the theme is changed.
     * @private
     */
    sas.hc.ui.commons.banner.Banner.prototype.onThemeChanged = function() {
        if (this.getDomRef()) {
            this.getAggregation("toolbar")._resetAndInvalidateToolbar(true);
            this.invalidate();
        }
    };

    /**
     * Check if the avatar changed.
     *
     * @param channel
     * @param event
     * @param data
     * @private
     */
    sas.hc.ui.commons.banner.Banner.prototype._handleSettingsChange = function(channel, event, data) {
        if (data[0] && (data[0].id === sas.hc.ui.core.GlobalSettings.PROFILE_PICTURE_CHOOSER_KEY)) {
            if(data[0].defaultAvatar) {//HTMLCOMMONS-8047

                this.setAvatar(sas.icons.HC.BANNERSETTINGS);
                if (window.outerWidth >= window.screen.width) {
                    this.optionsButton.setText(this.getUserName());
                    this.optionsButton.setIcon(null);
                } else {
                    this.optionsButton.setText("");
                    this.optionsButton.setIcon(this.getAvatar());
                }
            } else {
                // Add a dummy param to trick the browser into refetching the image.
                this.setAvatar("/identities/users/@currentUser/avatar/content/?test=" + this._dummy++);
                this.optionsButton.setText("");
                this.optionsButton.setIcon(this.getAvatar());
            }

            this.setDefaultAvatar(data[0].defaultAvatar);
            var toolTip = this.rb.getText("banner.avatar.fmt", [this.rb.getText("banner.userName.txt"),this.getUserName()]);
            this.optionsButton.setTooltip(toolTip);
            this.optionsButton.setShowDownArrowIconOnly(true);

            this.optionsButton.invalidate();
        }
    };

    /**
     * Calls the avatar service to determine if the avatar is the default (has not been changed by the user).
     *
     * @private
     */
    sas.hc.ui.commons.banner.Banner.prototype._getAvatar = function() {

        // First, see if the user has an avatar.  If not, try "group".  Check if the UserInfo exists.   It doesn't in the unit test environment.
        var that = this;
        var url = "/identities/users/@currentUser/avatar";
        var toolTip;

        // TODO: need a way to determine if this is a user group vs individual user.  The url is different.

        sas.ajax({type: "HEAD", async: true, url: url}).done(function() {
            // Find out if it's the default avatar.
            sas.ajax({type: "GET", async: true, url: url}).done(function(oJson){
                if (!oJson.default) {

                    that.setDefaultAvatar(false);
                    that.setAvatar(url + "/content");

                    // Since this is async, the button may not exist yet, or has been removed.
                    if (!that.optionsButton) {
                        return;
                    }

                    that.optionsButton.setText("");
                    that.optionsButton.setIcon( that.getAvatar() );

                    // Change the tooltip so that it includes more info.
                    toolTip = that.rb.getText("banner.avatar.fmt", [that.rb.getText("banner.userName.txt"),that.getUserName()]);
                    that.optionsButton.setTooltip(toolTip);
                    that.optionsButton.setShowDownArrowIconOnly(true);

                } else {
                    that.setDefaultAvatar(true);
                    that.setAvatar(sas.icons.HC.BANNERSETTINGS);
                }

                if (that.getShowOptionsMenu()) {
                    // Insert at the end
                    // When run from synchronous unit tests, this can be null b/c the unit test has finished before we get here.
                    if (that.getAggregation("toolbar")) {
                        that.getAggregation("toolbar").insertContent(that.optionsButton, 10);
                    }

                }

            }).fail(function(jqXHR, message, error) {

                // In this case, we'll use the  default icon: sas.icons.HC.USER
                if (sas.hc.ui.core.util.UserInfo.instance) {
                    that.logger.error("Failed to get avatar for user: " + sas.hc.ui.core.util.UserInfo.instance.userid + " server response: " + message );
                }
                if (that.optionsButton && that.getShowOptionsMenu()) {
                    that.getAggregation("toolbar").insertContent(that.optionsButton, 10);
                }
            });

        }).fail(function(jqXHR, message, error) {
            if (sas.hc.ui.core.util.UserInfo.instance) {
                that.logger.info("Avatar does not exist for user: " + sas.hc.ui.core.util.UserInfo.instance.userid );
            }

            if (that.optionsButton && that.getShowOptionsMenu()) {
                that.getAggregation("toolbar").insertContent(that.optionsButton, 10);
            }
        });
    };


    /**
     * Calls the preference service to determine if current user can get any preferences
     *
     * @private
     */
    sas.hc.ui.commons.banner.Banner.prototype._isSettingsAvailable = function() {


        // For wip, don't disallow settings.
        if (sas && sas.registry && sas.registry.wip && sas.registry.wip.getConfigurationService) {
            this.setShowSettings(true);
            return;
        }
        // First, see if the user has an avatar.  If not, try "group".  Check if the UserInfo exists.   It doesn't in the unit test environment.
        var that = this;

        var bPreferences = false;
        var url = "/preferences/preferences/@currentUser";

        sas.ajax({type: "GET", async: false, url: url}).done(function(oJson) {
            bPreferences = true;
        }).fail(function(jqXHR, message, error) {
            bPreferences = false;
            if (sas.hc.ui.core.util.UserInfo.instance) {
                that.logger.info("Settings not available for user: " + sas.hc.ui.core.util.UserInfo.instance.userid );
            }
        });

        this.setShowSettings(bPreferences);


    };

    sas.hc.ui.commons.banner.Banner.prototype._handleBannerImage = function(sChannelId, sEventId, themeObj) {
        var banner = this;
        var themeId = themeObj["themeId"];

        // Turn logo off initially
        banner.setShowLogo(false);

        // If this is not the default theme
        if (themeId !== sas.hc.ui.core.theme.ApplicationTheme.DEFAULT) {

            // Look for a banner logo id retrieved from the current theme info per JIRA HTMLTHMDES-993
            sas.themes.getCurrentThemeBannerImageUrl(function(logoUrl) {
                banner.setLogoSource(logoUrl);
                banner.setShowLogo(true);
            }, themeId);
        }
    };

    /**
     * If the browser has been maximized, restore the Search Field and Options menubutton if they have been
     * minimized.
     *
     * @method
     * @private
     */
    sas.hc.ui.commons.banner.Banner.prototype._onBrowserResize = function() {

        // S1372007 On Win10 Edge, the outerwidth is greater than the screen.
        if (window.outerWidth >= window.screen.width) {
            // Max width

            if (this.optionsButton) {
                if (this.optionsButton.getText().length === 0 && this.optionsButton._iOptimalWidthOriginal) {

                    if (this.getDefaultAvatar()) {
                        this.optionsButton.setText(this.getUserName());
                        this.optionsButton.setIcon(null);

                        // Reset avatar tooltip
                        var toolTip = this.rb.getText("banner.optionsMenu.tip");
                        this.optionsButton.setTooltip(toolTip);
                        this.optionsButton.setShowDownArrowIconOnly(false);
                    }
                }
            }

            // Do search.
            if (this.searchField) {
                if (this.getAggregation("toolbar").indexOfContent(this.searchButton) !== -1) {
                    // we can restore the searchfield.
                    var index = this.getAggregation("toolbar").indexOfContent(this.searchButton);
                    this.getAggregation("toolbar").removeContent(this.searchButton);
                    this.getAggregation("toolbar").insertContent(this.searchField, index);
                }
            }

            // Ensure the app name is displayed.
            this.bannerText.setShowText(true);


        }
    };

    sas.hc.ui.commons.banner.Banner.prototype._handleSearch = function() {
        if (this._searchDialog) {
            this._searchDialog.close();
        }
    };

    /**
     * Bring up the search dialog.
     *
     * @private
     */
    sas.hc.ui.commons.banner.Banner.prototype._onSearchPress = function() {
        var that = this;

        if (!this._searchDialog) {

            var rightButton = new sas.hc.m.Button(this.getId() + "-searchbuttonClose",{
                text: this.rb.getText("banner.searchDialogClose.label"),
                press: function () {
                    that.searchField.setValue("");
                    that._searchDialog.close();
                }
            });

            this._searchDialog = new sas.hc.m.Dialog(this.getId() + "-searchbuttondialog", {
                title: this.searchButton.getMenuItemText(),
                content: [
                    this.searchField
                ],
                rightButton: rightButton
            }).addStyleClass("bannerSearchFieldDialog");

            this.searchField.attachSearch(this._handleSearch, this);
        } else {

            // This is necessary b/c when the searchField is restored to the banner, it's implicitly removed from
            // the dialog content.
            this._searchDialog.addContent(this.searchField);
        }

        this._searchDialog.open();

    };


    /**
     * Implement ResponsiveContributor callback.  Restore options button, app name and searchfield.
     *
     * @public
     * @name sas.hc.ui.commons.banner.Banner#onBeforeRenderingDesktop
     * @function
     */
    sas.hc.ui.commons.banner.Banner.prototype.onBeforeRenderingDesktop = function() {


        // Restore the heading.
        if (this.bannerText.getTask())  {
            this.bannerText.setShowText(true);
            this.getAggregation("toolbar")._resetAndInvalidateToolbar(false);
        }


    };

    /**
     *  Don't know if this works.  Never seen it in action.
     *
     * @private
     */
    sas.hc.ui.commons.banner.Banner.prototype._setupThemeDesigner = function(){
        if(sas.applicationSwitcher) {
            var banner = this;
            sas.applicationSwitcher.subscribe("THEME_DESIGNER_OPEN", function (type, data) {
                jQuery.sap.require("sas.hc.ui.commons.themeDesigner.ApplicationThemePopup");
                window.setTimeout(function () {
                    sas.hc.ui.commons.themeDesigner.ApplicationThemePopup.show(banner.pushMenuButton, banner.optionsButton, data);
                }, 2000);
            });
        }
    };

    /**
     * Launch the help window.
     *
     * @private
     */
    sas.hc.ui.commons.banner.Banner.prototype._launchHelpMenuLink = function() {
        var that = this;
        var helpLink = that._helpLink;
        that.auxHelpWindow = window.open(helpLink, "SASAuxHelpPage");

        if (that.auxHelpWindow && that.auxHelpWindow.focus) {
            that.auxHelpWindow.focus();
        } else {
            // Help Center unable to open, display dialog
            sas.hc.ui.commons.banner.help.HelpAboutController.prototype._getPopupBlockedDialog();
        }
    };

    /**
     * Create the help menu button.
     *
     * @param helpLink
     * @param helpLinkName
     * @return {sas.hc.m.MenuButton}
     * @private
     */
    sas.hc.ui.commons.banner.Banner.prototype._getHelpButton = function() {
        if(this.helpButton === undefined) {
            this.helpButton = new sas.hc.m.MenuButton({
                id: this.getId() + "-help",
                icon: sas.icons.HC.BANNERHELP,
                tooltip:  this.rb.getText("banner.helpMenu.tip"),
                design:  sas.hc.m.MenuButton.Design.LightweightPrimary,
                layoutData: this.getAlwaysShowHelp() ? new sas.hc.m.OverflowToolbarLayoutData({priority: sapMLib.OverflowToolbarPriority.NeverOverflow}) :
                    new sap.m.OverflowToolbarLayoutData({priority: sapMLib.OverflowToolbarPriority.Low}),
                overflowPopupBehavior: sas.hc.m.MenuButton.OverflowPopupBehavior.Expand
            });
            this.helpButton.addStyleClass("sasBannerHelp");

            var helpMenuId = this.getId() + "-helpMenu";
            var helpMenu = new sas.hc.m.Menu(helpMenuId, {
                itemSelected: jQuery.proxy(this._helpMenuHandler, this),
                tooltip: this.rb.getText("banner.helpMenu.tip")
            });

            // Also attach listener to the overflow button menu.
            this.getAggregation("toolbar")._getOverflowButton().getMenu().attachItemSelected(jQuery.proxy(this._helpMenuHandler, this));

            var helpMenuItem = new sas.hc.m.MenuItem(this.getId() + "helpMenuItem", {
                text: this.rb.getText("banner.helpMenu.helpMenuItem.label")
            });
            var aboutMenuItem = new sas.hc.m.MenuItem(this.getId() + "aboutMenuItem", {
                text: this.rb.getText("banner.helpMenu.aboutMenuItem.label")
            });

            helpMenu.addItem(helpMenuItem);
            helpMenu.addItem(aboutMenuItem);
            this.helpButton.setMenu(helpMenu);

            // Set as aggregation so that the control is managed by openui lifecycle and auto getter/setters.
            this.setAggregation("helpButton", this.helpButton);

            if (this._bInitialized) {
                if (this.optionsButton) {
                    this.getAggregation("toolbar").insertContent(this.helpButton,
                        this.getAggregation("toolbar").indexOfContent(this.optionsButton));
                } else {
                    // To the end.
                    this.getAggregation("toolbar").addContent(this.helpButton);
                }
            }
        }
        return this.helpButton;
    };

    /**
     * Initialize the help controller.  Call the WIP service to get the urls for help.
     *
     * @return {sas.hc.m.MenuButton}
     * @private
     */
    sas.hc.ui.commons.banner.Banner.prototype._createHelpControl = function() {
        var that = this;

        // Create the Help button
        that._getHelpButton();

        if (sas && sas.registry && sas.registry.wip && sas.registry.wip.getConfigurationService) {
            var cfs = sas.registry.wip.getConfigurationService();

            // Async add additional help link once configuration service call returns
            try {
                // Retrieving SAS Application Infrastructure properties see if additional Help menu item should be added
                cfs.get({id: 'SAS Application Infrastructure'}).done(function (obj) {
                    obj.settings.forEach(function (prop) {
                        if (prop.key === "HelpMenuLink") {
                            that._helpLink = prop.value;
                        }
                        else if (prop.key === "HelpMenuLinkName") {
                            that._helpLinkName = prop.value;
                        }
                    });

                    if(that._helpLink && that._helpLinkName) {
                        var helpLinkMenuItem = new sas.hc.m.MenuItem(this.getId() + "helpLinkMenuItem", {
                            text: that._helpLinkName
                        });

                        that.helpButton.getMenu().insertItem(helpLinkMenuItem, 1);
                    }

                    return;
                });
            }catch(e){

                // An error occurred while trying to get the application properties
                that.logger.error("Error trying to get the help menu link from wip configuration service.");
            }
        }else {
            // If not WIP, then assume Viya
            var commonConfig = sas.config.get('commons') || {};
            var helpLink = commonConfig.additionalHelpMenuUrl;

            if (helpLink && helpLink.length > 0) {
                var helpLinkName = commonConfig.additionalHelpMenuLabel || this.rb.getText("banner.helpMenu.additionalHelpMenuLabel.label");

                that._helpLink = helpLink;
                that._helpLinkName = helpLinkName;

                var helpLinkMenuItem = new sas.hc.m.MenuItem(this.getId() + "helpLinkMenuItem", {
                    text: that._helpLinkName
                });

                that.helpButton.getMenu().insertItem(helpLinkMenuItem, 1);
            }
        }
    };

    /**
     * Create the notifications control.
     *
     * @return {sas.hc.ui.commons.notifications.NotificationsBadge|*}
     * @private
     */
    sas.hc.ui.commons.banner.Banner.prototype._createNotificationsControl = function() {

        if(this.notificationsControl === undefined) {
            this.notificationsControl =  new sas.hc.ui.commons.notifications.NotificationsBadge({
                id: this.getId() + "-notifications",
                design:  sas.hc.m.MenuButton.Design.LightweightPrimary,
                menuItemText: this.rb.getText("banner.optionsMenu.notificationsMenuItem.label"),
                layoutData: new sas.hc.m.OverflowToolbarLayoutData( {
                    priority: sapMLib.OverflowToolbarPriority.Low})

            });

            this.notificationsControl.addStyleClass("sasBannerNotifications");

            // Set as aggregation so that the control is managed by openui lifecycle and auto getter/setters.
            this.setAggregation("notifications", this.notificationsControl);

            if (this._bInitialized) {

                if (this.getAggregation("toolbar").indexOfContent(this.recentsButton) !== -1) {
                    this.getAggregation("toolbar").insertContent(this.notificationsControl,
                        this.getAggregation("toolbar").indexOfContent(this.recentsButton)+1);
                } else
                if (this.getAggregation("toolbar").indexOfContent(this.searchField) !== -1) {
                    this.getAggregation("toolbar").insertContent(this.notificationsControl,
                        this.getAggregation("toolbar").indexOfContent(this.searchField)+1);
                } else
                if (this.getAggregation("toolbar").indexOfContent(this.helpButton) !== -1) {
                    this.getAggregation("toolbar").insertContent(this.notificationsControl,
                        this.getAggregation("toolbar").indexOfContent(this.helpButton));
                } else
                if (this.getAggregation("toolbar").indexOfContent(this.optionsButton) !== -1) {
                    this.getAggregation("toolbar").insertContent(this.notificationsControl,
                        this.getAggregation("toolbar").indexOfContent(this.optionsButton));
                } else {
                    this.getAggregation("toolbar").addContent(this.notificationsControl,
                        this.getAggregation("toolbar").indexOfContent(this.optionsButton));
                }

            }


        }

        return this.notificationsControl;
    };

    /**
     * Create the search control.
     *
     * @return {sas.hc.ui.services.search.CincoSearchField|*}
     * @private
     */
    sas.hc.ui.commons.banner.Banner.prototype._createSearchControl = function() {
        if (this.searchField === undefined) {
            this.searchField = new sas.hc.ui.services.search.CincoSearchField(this.getId() + "-searchField", {
                bannerExpandOnClick: false,
                layoutData: new sas.hc.m.OverflowToolbarLayoutData( {
                    priority: sapMLib.OverflowToolbarPriority.Low})
            });

            // Set as aggregation so that the control is managed by openui lifecycle and auto getter/setters.
            this.setAggregation("search", this.searchField);
        }

        if (!this.searchButton) {

            this.searchButton = new sas.hc.m.Button(this.getId() + "searchButton", {
                tooltip: this.rb.getText("banner.overflow.searchMenuItem.label"),
                menuItemText: this.rb.getText("banner.overflow.searchMenuItem.label"),
                ariaLabel: this.rb.getText("banner.overflow.searchMenuItem.label"),
                icon: sas.icons.HC.SEARCH,
                press: jQuery.proxy(this._onSearchPress, this),
                design: sas.hc.m.Button.Design.LightweightPrimary,
                layoutData: new sas.hc.m.OverflowToolbarLayoutData( {
                    priority: sapMLib.OverflowToolbarPriority.Low})
            });
        }

        // Depending on how much room is available, add the field or the button.
        var tb = this.getAggregation("toolbar");
        var iContentSize = tb._iContentSize;
        var tbWidth = tb.$().outerWidth(true);

        if (this._bInitialized) {

            if (iContentSize + (this.searchField._iOptimalWidth ? this.searchField._iOptimalWidth : 224) < tbWidth) {
                this.getAggregation("toolbar").insertContent(this.searchField,
                    this.getAggregation("toolbar").indexOfContent(this.toolbarSpacer) + 1);
            } else {
                this.getAggregation("toolbar").insertContent(this.searchButton,
                    this.getAggregation("toolbar").indexOfContent(this.toolbarSpacer) + 1);
            }
        }


        return this.searchField;
    };

    /**
     * Set the show search property.
     *
     * @param showSearch boolean  Noop if it's not different.
     * @return {sas.hc.ui.commons.banner.Banner}
     */
    sas.hc.ui.commons.banner.Banner.prototype.setShowSearch = function(showSearch){

        if (showSearch === this.getShowSearch()) {
            return;
        }

        this.setProperty("showSearch", showSearch);

        if (this.getShowSearch()) {
            this._createSearchControl();
            this.searchField.setVisible(true);

        }  else {
            if (!showSearch && this.searchField) {
                this.getAggregation("toolbar").removeContent(this.searchField);
                this.searchField.destroy();
                delete this.searchField;
                if (this.searchButton) {
                    this.getAggregation("toolbar").removeContent(this.searchButton);
                    this.searchButton.destroy();
                    delete this.searchButton;
                }
                this.setAggregation("search", undefined);
            }
        }

        return this;
    };

    sas.hc.ui.commons.banner.Banner.prototype.setShowNotifications = function(showNotifications){
        if(showNotifications) {
            this._createNotificationsControl();
            this.notificationsControl.setVisible(true);
        } else {
            if (this.notificationsControl) {
                this.getAggregation("toolbar").removeContent(this.notificationsControl);
                this.notificationsControl.destroy();
                this.notificationsControl = undefined;
                this.setAggregation("notifications", undefined);
            }
        }

        this.setProperty("showNotifications", showNotifications);

        return this;
    };


    /**
     * Bring up help.  This calls the help controller.
     *
     * @private
     */
    sas.hc.ui.commons.banner.Banner.prototype._launchHelpSystem = function(){

        this._createHelpController();

        if(this.helpButton !== undefined && this.helpButton.getVisible() === true){
            this._helpAboutController.show(this.helpButton);
        } else {
            this._helpAboutController.show(this.optionsButton);
        }
    };


    /**
     * This displays the recents dialog.
     *
     * @private
     */
    sas.hc.ui.commons.banner.Banner.prototype._launchRecentsDialog = function(){

        // In some cases, if the user clicks the button twice a second event before the button is disabled.  Make sure the
        // button is disabled immediately.
        this.recentsButton.setEnabled(false);

        var dlg = new sas.hc.ui.commons.recent.RecentDialog(this.getId() + "-recentsDialog");
        var that = this;
        dlg.attachAfterClose(function() {
            dlg.destroy();
            if (that.recentsButton) {

                // When run during unit tests, this might be undefined, if the test has closed before we get here.
                that.recentsButton.setEnabled(true);
            }

        });

        var recentItemClickHandler = function(e){
            var item = e.getParameter("recentItem");
            if (sas.applicationSwitcher) {

                var data = {};

                if (item.targetReposKey) {
                    data.targetReposKey = item.targetReposKey;
                    data.targetNavPath = item.targetNavPath;
                } else if (item.uri) {
                    data.targetUri = item.uri;
                    data.targetNavPath = item.uri;
                }

                data.targetPublicType = item.contentType;

                sas.applicationSwitcher.openObject(
                    item.contentType,
                    data,
                    sas.config.getAppId()
                );
            }
            dlg.detachRecentItemClick(recentItemClickHandler);
        };

        dlg.attachRecentItemClick(recentItemClickHandler);
        dlg.open();
    };

    /**
     * Handle the help menu
     *
     * @param event
     * @private
     */
    sas.hc.ui.commons.banner.Banner.prototype._helpMenuHandler = function(event) {
        var bannerId = this.getId();
        var menuItemId = event.getParameter("item").getId();

        switch(menuItemId) {
            case bannerId + "helpMenuItem":
                if(sas && sas.eventBus){
                    sas.eventBus.publish("helpAbout", "openHelpCenter");
                }
                break;
            case bannerId + "aboutMenuItem":
                if(sas && sas.eventBus){
                    sas.eventBus.publish("helpAbout", "toAbout", {aboutAnchor: this.helpButton} );
                }
                break;
            case bannerId + "helpLinkMenuItem":
                this._launchHelpMenuLink();
            default:
                this.logger.info("Unknown help menu item : " + menuItemId);
                break;
        }
    };

    sas.hc.ui.commons.banner.Banner.prototype._optionsMenuHandler = function(event) {
        var bannerId = this.getId();
        var menuItemId = event.getParameter("item").getId();
        switch(menuItemId) {
            case bannerId + "-signoutMenuItem":

                // Nobody should really be setting the signout url on the banner directly.  Must be
                // a very special case to not be using app switcher logoff.
                sas.hc.ui.core.util.signout();
                break;
            case bannerId + "-settingsMenuItem":
                // fire a before show settings event. preventable.
                // no settings dialog shown if prevented.
                if(this.fireBeforeShowSettings()){
                    jQuery.sap.require("sas.hc.ui.commons.settings.Settings");
                    sas.hc.ui.commons.settings.Settings.show();
                }
                break;
            default:
                this.logger.info("Unknown menu item : " + menuItemId);
                break;
        }
    };

    /**
     * Handle the app switcher button.
     * @Deprecated Will be removed soon.
     */
    sas.hc.ui.commons.banner.Banner.prototype.toggleExpandCollapseState = function() {
        if(this._appswitchMenu){
            // fire beforeTogglePushMenu event to which consumers can listen to and decide
            // if the user action is supported/whatever. Consumers are expected to call
            // preventDefault on the event if user action is invalid which then
            // will prevent default action of toggling the menu
            if(this.fireBeforeTogglePushMenu({collapsed:this._appswitchMenu.isFullyCollapsed()})){
                this._appswitchMenu.toggleExplandCollapseState();
            }
        }
    };

    sas.hc.ui.commons.banner.Banner.prototype.setShowPushMenu = function(showPushMenu) {
        if (showPushMenu === true && this.pushMenuButton === undefined) {
            this.pushMenuButton = new sas.hc.m.Button({
                id: this.getId() + "-appSwitcher",
                ariaLabel: this.rb.getText("banner.sideMenu.ariaLabel"),
                tooltip:  this.rb.getText("banner.sideMenu.tip"),
                icon: sas.icons.HC.SIDEMENUBUTTON,
                press: this.toggleExpandCollapseState.bind(this),
                design:  sas.hc.m.MenuButton.Design.LightweightPrimary,
                layoutData: new sas.hc.m.OverflowToolbarLayoutData({priority: sapMLib.OverflowToolbarPriority.NeverOverflow}),
                hasPopup: true
            });

            this.pushMenuButton.addStyleClass("sasBannerPushMenu");
            setupAppSwitcherMenu.call(this);
            // Set as aggregation so that the control is managed by openui lifecycle and auto getter/setters.
            this.setAggregation("pushMenuButton", this.pushMenuButton);

            if (this._bInitialized) {
                this.getAggregation("toolbar").insertContent(this.pushMenuButton,0);
            }

        } else
        if (!showPushMenu && this.pushMenuButton) {
            this.getAggregation("toolbar").removeContent(this.pushMenuButton);
            this.pushMenuButton.destroy();
            this.pushMenuButton = undefined;
            this.setAggregation("pushMenuButton", undefined);
        }


        this.setProperty("showPushMenu", showPushMenu);
        return this;
    };

    /**
     * Handle showing or hiding the recents button.
     *
     * @param show
     * @return {sas.hc.ui.commons.banner.Banner}
     */
    sas.hc.ui.commons.banner.Banner.prototype.setShowRecents = function(show) {
        if (show === true && this.recentsButton === undefined) {
            this.recentsButton = new sas.hc.m.Button({
                id: this.getId() + "-recents",
                menuItemText: this.rb.getText("banner.recents.txt"),
                tooltip:  this.rb.getText("banner.recents.tip"),
                icon: sas.icons.HC.BANNERRECENTITEMS,
                press: this._launchRecentsDialog.bind(this),
                design:  sas.hc.m.MenuButton.Design.LightweightPrimary,
                layoutData: new sas.hc.m.OverflowToolbarLayoutData( {
                    priority: sapMLib.OverflowToolbarPriority.Low})
            });

            this.recentsButton.addStyleClass("sasBannerRecentItems");

            // Set as aggregation so that the control is managed by openui lifecycle and auto getter/setters.
            this.setAggregation("recentsButton", this.recentsButton);

            if (this._bInitialized) {
                if (!this.getShowSearch()) {
                    this.getAggregation("toolbar").insertContent(this.recentsButton,
                        this.getAggregation("toolbar").indexOfContent(this.toolbarSpacer)+1);
                } else {

                    if (this.getAggregation("toolbar").indexOfContent(this.searchField) === -1 &&
                        this.getAggregation("toolbar").indexOfContent(this.searchButton) !== -1) {
                        this.getAggregation("toolbar").insertContent(this.recentsButton,
                            this.getAggregation("toolbar").indexOfContent(this.searchButton)+1);
                    } else {
                        this.getAggregation("toolbar").insertContent(this.recentsButton,
                            this.getAggregation("toolbar").indexOfContent(this.searchField)+1);
                    }
                }
            }
        } else {
            if (!show && this.recentsButton) {
                this.getAggregation("toolbar").removeContent(this.recentsButton);
                this.recentsButton.destroy();
                this.recentsButton = undefined;
                this.setAggregation("recentsButton", undefined);
            }

        }

        this.setProperty("showRecents", show);
        return this;
    };


    /**
     * This is the app text.  Usually comes from configuration object.
     *
     * @return {*}
     */
    sas.hc.ui.commons.banner.Banner.prototype.getText = function() {
        //  Unless app explicitly overrides appname via setText we will
        // look up the appName via prepopulated config object
        var appName = this.getProperty("text");
        var sSubText = this.getProperty("subText");
        if (appName !== "" || sSubText !== "") {
            return appName;
        } else {
            if (sas.applicationSwitcher && sas.config && sas.hc.ui.core.util.ServicesUtil.getServicePlatform() === "PETRICHOR") {
                var sAppId = sas.config.getAppId();
                var fCompare = function(oApp) {
                    return oApp.appId === sAppId;
                };

                var oApplication = sas.applicationSwitcher.findApplication(fCompare);

                if (oApplication) {
                    if (oApplication.appName) {
                        return $("<div></div>").html(oApplication.appName).text();
                    } else if (oApplication.label) {
                        return $("<div></div>").html(oApplication.label).text();
                    }
                } else {
                    return sas.config.getAppName();
                }
            } else if (sas && sas.config) {
                return sas.config.getAppName();
            }
        }
    };

    /**
     * Set the app text.  Optional
     *
     * @param bannerText
     * @return {sas.hc.ui.commons.banner.Banner}
     */
    sas.hc.ui.commons.banner.Banner.prototype.setText = function(bannerText){
        var bannerTxtCntr = this.bannerText;
        if(bannerTxtCntr){
            bannerTxtCntr.setText(bannerText);

            var s = bannerTxtCntr.getFormattedString();
            // Update the page title.
            $("head title").text(s);
        }
        this.setProperty("text", bannerText);
        if (bannerTxtCntr) {
            bannerTxtCntr.setSubText(this.getProperty("subText"));
        }
        return this;
    };

    /**
     * This is the app sub text.
     *
     * @return {*}
     */
    sas.hc.ui.commons.banner.Banner.prototype.getSubText = function() {
        //  Unless app explicitly overrides appname via setText we will
        // look up the appName via prepopulated config object
        var sText = this.getProperty("text");
        var sSubText = this.getProperty("subText");
        var sReturnValue = "";
        if (sSubText !== "" || sText !== "") {
            sReturnValue = sSubText;
        } else if (sas.applicationSwitcher && sas.config && sas.hc.ui.core.util.ServicesUtil.getServicePlatform() === "PETRICHOR") {
            var sAppId = sas.config.getAppId();
            var fCompare = function(oApp) {
                return oApp.appId === sAppId;
            };

            var oApplication = sas.applicationSwitcher.findApplication(fCompare);

            if (oApplication && oApplication.label) {
                var sHtmlText = $("<div></div>").html(oApplication.label).text();
                if (sHtmlText !== this.getText()) {
                    sReturnValue = sHtmlText;
                } else {
                    sReturnValue = "";
                }
            }
        }

        return sReturnValue;
    };

    /**
     * Set the app sub text.  Optional
     *
     * @param bannerText
     * @return {sas.hc.ui.commons.banner.Banner}
     */
    sas.hc.ui.commons.banner.Banner.prototype.setSubText = function(value){
        var bannerTxtCntr = this.bannerText;
        if(bannerTxtCntr){
            bannerTxtCntr.setSubText(value);
        }
        this.setProperty("subText", value);
        if (bannerTxtCntr) {
            var s = bannerTxtCntr.getFormattedString();
            // Update the page title.
            $("head title").text(s);
        }
        return this;
    };

    /**
     * Set the the task name.  Optional.
     *
     * @param taskText
     * @return {sas.hc.ui.commons.banner.Banner}
     */
    sas.hc.ui.commons.banner.Banner.prototype.setTask = function(taskText){
        var bannerTxtCntr = this.bannerText;
        if(bannerTxtCntr){
            bannerTxtCntr.setTask(taskText);
            if (!taskText || taskText.length === 0) {
                // If task is being removed, make sure show text is true in case the banner is narrow and
                // show text was set to false.
                bannerTxtCntr.setShowText(true);
            }

            var s = bannerTxtCntr.getFormattedString();
            // Update the page title.
            $("head title").text(s);
        }
        this.setProperty("task", taskText);
        return this;
    };

    /**
     * Set the logo image source.
     *
     * @param name
     * @return {sas.hc.ui.commons.banner.Banner}
     */
    sas.hc.ui.commons.banner.Banner.prototype.setLogoSource = function(name){
        this.setProperty("logoSource", name);
        if (this.logoImage) {
            this.logoImage.setSrc(name);
        }

        return this;
    };

    /**
     * Set the logo image source.
     *
     * @param name
     * @return {sas.hc.ui.commons.banner.Banner}
     */
    sas.hc.ui.commons.banner.Banner.prototype.setLogoTooltip = function(name){
        this.setProperty("logoSource", name);
        if (this.logoImage) {
            this.logoImage.setTooltip(name);
        }

        return this;
    };

    /**
     * Set the logo image source.
     *
     * @param name
     * @return {sas.hc.ui.commons.banner.Banner}
     */
    sas.hc.ui.commons.banner.Banner.prototype.setShowLogo = function(b){

        this.setProperty("showLogo", b);
        if (b && this.getProperty("logoSource")) {

            if (!this.logoImage) {
                // Create a new one.
                this.logoImage = new sas.hc.m.Image({
                    id: this.getId() + "logoImage",
                    src: this.getProperty("logoSource")
                });

                this.logoImage.attachLoad(this._handleLogoLoad, this);

                this.setAggregation("logo", this.logoImage);
            } else {
                this.logoImage.setVisible(true);
            }
        } else
        if (!b && this.logoImage) {
            this.logoImage.setVisible(false);
        }

    };

    /**
     *  Perform some post processing of the logo.
     *
     * @return {string}
     */
    sas.hc.ui.commons.banner.Banner.prototype._handleLogoLoad = function(){

        var width = $($(".logo > img", this.$())[0]).outerWidth(true) + "px";
        $($(".logo", this.$())[0]).css("width", width);
    };

    /**
     * Get the logo image source.
     *
     * @return {string}
     */
    sas.hc.ui.commons.banner.Banner.prototype.getLogoSource = function(){
        return this.getProperty("logoSource");
    };


    /**
     * Set the user name.  Optional. Usually comes from configuration object.
     *
     * @param userName
     * @return {sas.hc.ui.commons.banner.Banner}
     */
    sas.hc.ui.commons.banner.Banner.prototype.setUserName = function(userName){
        this.setProperty("userName", userName);
        if (this.optionsButton) {
            this.optionsButton.setText(userName);
        }

        return this;
    };

    /**
     *  Retrieve the user name.
     *  @returns {string} TODO-jsdoc
     */
    sas.hc.ui.commons.banner.Banner.prototype.getUserName = function() {

        // Unless app explicitly override username via setUserName we will
        // look up the username via pre-populated config object.
        var uname = this.getProperty("userName");
        if (uname !== "") {
            return uname;
        } else {
            if(sas.hc.ui.core.util.UserInfo.instance){
                uname = sas.hc.ui.core.util.UserInfo.instance.displayName;
                this.setUserName(uname);
                return uname;
            }
        }

        return null;
    };


    /**
     * Set the override help URL to use
     *
     * @param {string} helpUrl TODO-jsdoc
     * @returns {sas.hc.ui.commons.banner.Banner} TODO-jsdoc
     */
    sas.hc.ui.commons.banner.Banner.prototype.setHelpUrl = function(helpUrl) {
        this.setProperty("helpUrl", helpUrl);
        // update the help url if help controller is already created.
        if ( typeof this._helpAboutController !== 'undefined' && this._helpAboutController ){
            this._helpAboutController.setHelpUrl(this.getHelpUrl());
        }
        return this;
    };


    /**
     * Handle changes to the banner heading.   If it changes size (either the app name or the task name), it
     * may affect the other controls.   E.g. SearchField may flip to a button or vice version.
     *
     * This calls the handlers for the banner resize.   Unfortunately, when  the heading changes, the banner
     * size does not change so those other handlers ignore it. Plus, the actual size of the header is not known
     * until it's rendered.  So, if increasing the banner heading causes overflow, we would have to somehow
     * intercept the overflow and change the buttons then.
     *
     * @param oEvent
     * @private
     */
    sas.hc.ui.commons.banner.Banner.prototype._onHeadingPropertyChangedOverflowToolbar = function (oEvent) {


        var sSourceControl = oEvent.getSource();
        var sParameterName = oEvent.getParameter("name");

        // If the text is hidden, we not have some more room.
        if (sParameterName === "showText" && sSourceControl.getShowText() === false) {
            // We have reduced the " to the task.  See if we can modify
            // the other controls.
            if (!sSourceControl.getShowText()) {
                this._handleAdditionalSpace(oEvent);
            } else {
                // We have reduced the heading to the task.  See if we can modify
                // the other controls.
                this._handleLessSpace(oEvent);
            }
        } else
        if (sParameterName === "text") {
            // We have reduced the heading to the task.  See if we can modify
            // the other controls.
            if ( !oEvent.mParameters.newValue || oEvent.mParameters.newValue.length < oEvent.mParameters.oldValue ? oEvent.mParameters.oldValue.length : 0) {
                this._handleAdditionalSpace(oEvent);
            } else {
                // We have reduced the heading to the task.  See if we can modify
                // the other controls.
                this._handleLessSpace(oEvent);
            }
        } else
        if (sParameterName === "task") {
            // Check if the task name length has changed.
            if ( !oEvent.mParameters.newValue || oEvent.mParameters.newValue.length < oEvent.mParameters.oldValue ? oEvent.mParameters.oldValue.length : 0) {
                this._handleAdditionalSpace(oEvent);
            } else {
                // We have reduced the heading to the task.  See if we can modify
                // the other controls.
                this._handleLessSpace(oEvent);
            }
        }else
        if (sParameterName === "subText") {
            // Check if the task name length has changed.
            if ( !oEvent.mParameters.newValue || oEvent.mParameters.newValue.length < oEvent.mParameters.oldValue ? oEvent.mParameters.oldValue.length : 0) {
                this._handleAdditionalSpace(oEvent);
            } else {
                // We have reduced the heading to the task.  See if we can modify
                // the other controls.
                this._handleLessSpace(oEvent);
            }
        }


    };


    /**
     * Retrieve the help url.
     * @returns {string} TODO-jsdoc
     */
    sas.hc.ui.commons.banner.Banner.prototype.getHelpUrl = function() {
        return this.getProperty("helpUrl");
    };

    /**
     * @param {boolean} bShow TODO-jsdoc
     * @private
     */
    sas.hc.ui.commons.banner.Banner.prototype._showTextControl = function(bShow){
        if (bShow === true) {
            if (this.bannerText === undefined) {
                var bannerId = this.getId();
                this.bannerText = new sas.hc.m.BannerHeading({
                    id: bannerId + "-bannerheading",
                    level: 1,
                    text: this.getText(),
                    task: this.getSubText(),
                    subText: this.getTask()
                });

                // getText did not actually save the value.
                this.setText(this.getText());
                this.bannerText.addStyleClass("sasBannerText");
                this.setAggregation("appTextControl", this.bannerText);

                this.bannerText.attachEvent("_change", this._onHeadingPropertyChangedOverflowToolbar, this);
            }
            this.bannerText.setVisible(true);
        } else {
            if (this.bannerText) {
                this.bannerText.setVisible(false);
            }
        }
    };

    /**
     * Create help controller.
     * @private
     */
    sas.hc.ui.commons.banner.Banner.prototype._createHelpController = function(){
        if(!this._helpAboutController){

            this._helpAboutController = new sas.hc.ui.commons.banner.help.HelpAboutController();
            this._helpAboutController.setHelpUrl(this.getHelpUrl());

            if (!this._helpCenterPage) {
                this._helpCenterPage = new sas.hc.ui.commons.banner.help.DefaultHelpPage(this.getId() + "-helpCenterPage", {});
            }

            if(this._helpCenterPage){
                this._helpAboutController.setHelpCenterPage(this._helpCenterPage);
            }
        }
    };

    /**
     * Setter to toggle visibility of options menu in Banner.
     * @public
     * @name sas.hc.ui.commons.banner.Banner.setShowOptionsMenu
     * @param {boolean} showOptionsMenu Whether to toggle options menu.
     * @returns {sas.hc.ui.commons.banner.Banner} TODO-jsdoc
     */
    sas.hc.ui.commons.banner.Banner.prototype.setShowOptionsMenu = function(showOptionsMenu){

        var that = this;

        if (showOptionsMenu === true && this.optionsButton === undefined){
            var bannerId = this.getId();
            this.optionsButton = new sas.hc.m.MenuButton({
                id: bannerId + "-options",
                tooltip:  this.rb.getText("banner.optionsMenu.tip"),
                design:  sas.hc.m.MenuButton.Design.LightweightPrimary,
                text: this.getUserName(),
                overflowPopupBehavior: sas.hc.m.MenuButton.OverflowPopupBehavior.Expand,
                layoutData: new sas.hc.m.OverflowToolbarLayoutData( {
                    priority: sapMLib.OverflowToolbarPriority.High}),
                showDownArrowIconOnly: true
            });

            var f = {
                onAfterRendering: function() {
                    if (that.getDefaultAvatar()) {
                        return;
                    }
                    // Change the inner span so that it has a special class
                    $(".sapMBtnInner ", that.optionsButton.$()).addClass("sasAvatar");
                }
            };
            this.optionsButton.addDelegate(f);

            if (!this.getDefaultAvatar()) {
                // If it's a custom avatar, do not show the user name;
                this.optionsButton.setText("");
                this.optionsButton.setIcon("/identities/users/@currentUser/avatar/content");

                // Change the tooltip so that it includes more info.
                var toolTip = this.rb.getText("banner.avatar.fmt", [this.rb.getText("banner.userName.txt"),this.getUserName()]);
                this.optionsButton.setTooltip(toolTip);
                this.optionsButton.setShowDownArrowIconOnly(true);
            }

            this.optionsButton.addStyleClass("sasBannerOptions");
            var optionsMenuId = this.getId() + "-optionsMenu";
            var optionsMenu = new sas.hc.m.Menu(optionsMenuId, {
                // ariaDescription: this.rb.getText("banner.optionsMenu.label"),
                tooltip: this.rb.getText("banner.optionsMenu.tip"),
                itemSelected : jQuery.proxy(this._optionsMenuHandler, this)
            });

            // S1334094: for banner, menu alignment flips (right in LTR, left in RTL)
            optionsMenu.setFlipRtl(true);

	        //Create the items and add them to the menu
            if (this.getShowSettings()) {
                var settingsMenuId = this.getId() + "-settingsMenuItem";
                var settingsMenuItem = new sas.hc.m.MenuItem(settingsMenuId, {
                    text: this.rb.getText("banner.optionsMenu.settingsMenuItem.label")
                });
                optionsMenu.addItem(settingsMenuItem);
            }

            // In unit test, this method may get called in a delayed fashion after trying to fetch the avatar and the test has already
            // concluded and the toolbar has been destroyed.
            if (this.getAggregation("toolbar")) {
                this.getAggregation("toolbar")._getOverflowButton().getMenu().attachItemSelected(jQuery.proxy(this._optionsMenuHandler, this));
            }


            //Create the items and add them to the menu
            var signoutMenuItemId = bannerId + "-signoutMenuItem";
            var signoutMenuItem = new sas.hc.m.MenuItem(signoutMenuItemId, {
                text: this.rb.getText("banner.optionsMenu.signOutMenuItem.label")
            });
            optionsMenu.addItem(signoutMenuItem);
            this.optionsButton.setMenu(optionsMenu);

            // Set as aggregation so that the control is managed by openui lifecycle and auto getter/setters.
            this.setAggregation("optionsButton", this.optionsButton);

            if (this._bInitialized) {
                if (this.getAggregation("toolbar")) {
                    this.getAggregation("toolbar").insertContent(this.optionsButton,
                        this.getAggregation("toolbar").indexOfContent(this.helpButton) + 1);
                }
            }

        }  else
        if (showOptionsMenu !== true && this.optionsButton ){
            this.getAggregation("toolbar").removeContent(this.optionsButton);
            this.optionsButton.destroy();
            this.optionsButton = undefined;
            this.setAggregation("optionsButton", undefined);
        }


        this.setProperty("showOptionsMenu", showOptionsMenu);
        return this;
    };

    /**
     * Setter to always show help icon in the banner.
     *
     * TODO this should modify the help control so that it never overflows.  Currently not used.
     *
     * @public
     * @name sas.hc.ui.commons.banner.Banner.setAlwaysShowHelp
     * @param {boolean} showHelp TODO-jsdoc
     * @returns {sas.hc.ui.commons.banner.Banner} TODO-jsdoc
     * @see sas.hc.ui.commons.banner.Banner.setShowOptionsMenu
     */
    sas.hc.ui.commons.banner.Banner.prototype.setAlwaysShowHelp = function(showHelp){

        if (this.getAlwaysShowHelp() === showHelp) {
            return;
        }

        // Always show help is false by default.  So, to recreate the help button
        // we need to delete the existing one.
        this.setProperty("alwaysShowHelp", showHelp);

        this.getAggregation("toolbar").removeContent(this.helpButton);
        this.helpButton.destroy();
        this.helpButton = undefined;

        this._createHelpControl();

        return this;
    };

    /**
     * Getter for show search property on banner. Returns true if show search is set to true and search functionality
     * is available.
     * @returns {boolean} TODO-jsdoc
     */
    sas.hc.ui.commons.banner.Banner.prototype.getShowSearch = function(){
        if(typeof sas.hc.ui.services.search.CincoSearchField.isAvailable === "function" ){
            return this.getProperty("showSearch") && sas.hc.ui.services.search.CincoSearchField.isAvailable();
        }
        return this.getProperty("showSearch");
    };

    sas.hc.ui.commons.banner.Banner.prototype.getShowThemeDesigner = function(){
        //TODO: replace with check for theme designer service and user capabilities
        return this.getProperty("showThemeDesigner");
    };

    sas.hc.ui.commons.banner.Banner.prototype.setSignoutUrl = function(sUrl){
        this.setProperty("signoutUrl", sUrl);
        var signoutSrv = sas.hc.ui.core.util.SignoutService.instance;
        if(signoutSrv && signoutSrv.setSignoutUrl){
            signoutSrv.setSignoutUrl(this.getSignoutUrl());
        }
        return this;
    };

    /**
     * S1340664
     *
     * Manually set the focus.
     *
     * @public
     * @function
     * @name sas.hc.ui.commons.banner.Banner.prototype.onAfterRendering
     * @returns {*}
     */
    sas.hc.ui.commons.banner.Banner.prototype.onAfterRendering = function () {
        this.getFocusDomRef().focus();
    };

    /**
     * S1302738
     *
     * Cleanup memory.
     *
     * @public
     * @function
     * @name sas.hc.ui.commons.banner.Banner.prototype.exit
     * @returns {*}
     */
    sas.hc.ui.commons.banner.Banner.prototype.exit = function () {

        sas.eventBus.unsubscribe("Themes", "applicationThemeChanged", this._handleBannerImage, this);
        sas.eventBus.unsubscribe(sasCoreLib.SETTINGS_CHANNEL, sasCoreLib.SETTINGS_CHANGE,
            this._handleSettingsChange, this);

        if (this._helpAboutController) {
            this._helpAboutController.setHelpCenterPage(undefined);
            this._helpAboutController.destroy();
            delete this._helpAboutController;
        }

        if (this._helpCenterPage) {
            this._helpCenterPage.destroy();
            delete this._helpCenterPage;
        }

        if (this.helpButton) {
            this.helpButton.destroy();
            delete this.helpButton;
        }

        if (this.optionsButton) {
            this.optionsButton.destroy();
            this.setAggregation("optionsButton", null);
            delete this.optionsButton;
        }

        if (this.searchButton) {
            this.searchButton.destroy();
            delete this.searchButton;
        }

        if (this.searchField) {
            this.searchField.detachSearch(this._handleSearch);
            this.searchField.destroy();
            delete this.searchField;
        }

        if (this.recentsButton) {
            this.recentsButton.destroy();
            delete this.recentsButton;
        }

        if (this.bannerText) {
            this.bannerText.detachEvent("_change", this._onHeadingPropertyChangedOverflowToolbar);
            this.bannerText.destroy();
            delete this.bannerText;
        }


        if (this._searchDialog) {
            this._searchDialog.destroy();
            delete this._searchDialog;
        }

        this.getAggregation("toolbar")._getOverflowButton().getMenu().detachEvent("itemSelected",this._optionsMenuHandler);

        if (this.getAggregation("toolbar")) {
            this.getAggregation("toolbar").detachEvent("additionalSpaceAvailable", this._handleAdditionalSpace);
            this.getAggregation("toolbar").detachEvent("lessSpaceAvailable", this._handleLessSpace);
            this.getAggregation("toolbar").detachEvent("beforeOverflow", this._handleOverflow);
            this.getAggregation("toolbar").destroy();
        }

        if (this.logoImage) {
            this.logoImage.detachLoad(this._handleLogoLoad, this);
        }


        $(window).unbind('resize', this._onBrowserResize);

    };


    /**
     * The notifications HC sample needs access to the NotificationsBadge, make it available.
     *
     * @public
     * @function
     * @name sas.hc.ui.commons.banner.Banner.prototype.getNotifications
     * @returns {*}
     */
    sas.hc.ui.commons.banner.Banner.prototype.getNotifications = function(){
        return this.notificationsControl;
    };

}());
