/**
 * Created by betoml on 5/1/2015.
 */
jQuery.sap.require("sap.ui.core.Core");
jQuery.sap.require("sas.hc.ui.commons.themeDesigner.InContextHelper");
jQuery.sap.require("sas.hc.ui.core.ListItem");

sap.ui.controller("sas.hc.ui.commons.themeDesigner.InContextDialogPanel", {

    rb: sap.ui.getCore().getLibraryResourceBundle("sas.hc.ui.commons"),

    buildApplicationSelect: function(){
        this.getView().applicationSelect.removeAllItems();

        sas.hc.ui.commons.themeDesigner.InContextHelper.applications.forEach(function(object){
            var label = $("<div></div>").html(object.appName).text();
            if (!label)
                label = object.label;

            this.getView().applicationSelect.addItem(
                new sas.hc.ui.core.ListItem({
                    text: label,
                    key: object.appId
                }).data("application", object)
            );
        }, this);

        this.getView().setBusy(false);
    },

    onInit: function(){
        this.getView().setBusy(true);

        this.getView().applicationSelect.addItem(
            new sas.hc.ui.core.ListItem({
                text: this.rb.getText("ThemeDesigner.inContextDialog.applicationList.loading.txt")
            })
        );

        var that = this;

        sas.hc.ui.commons.themeDesigner.InContextHelper.loadApplicationList(function(){
            that.buildApplicationSelect();
        });

    },

    getSelectedApplication: function(){
        return this.getView().applicationSelect.getSelectedItem().data("application");
    }
});
